//==============================================================
//	Nom Programme	: Picky_6.c
//	Date			: 9-08-2006
//	Version			: 1.0
//	Auteur			: F. Giamarchi
//
//	Description	: 	Etude de divers capteurs sur un robot
//			
//	1.0 (9-08-2006):	Programme de base
//==============================================================	
//	Appel des sous-programmes utiles
//==============================================================
#include <16f88.h>
#include <Picky_6.h>
#include <Int_Picky_6.h>
#include <Ext_LDR.h>
//==============================================================
//	Routine pilote des moteurs
//==============================================================
signed	int	Vitesse_Dr, Vitesse_Ga;
void	Active_Moteurs()
{
	Vitesse_Dr = Vitesse_Moy + Rotation;
	Vitesse_Ga = Vitesse_Moy - Rotation;

//	Moteur droit
	if (Vitesse_Dr < 0)
		{
		Sens_Dr = 1;	// marche arrire
		Vitesse_Dr = abs(Vitesse_Dr);
		}
	else
		Sens_Dr = 0;	// marche avant

	if (Vitesse_Dr > 30)
		Vitesse_Dr = 30;
	Vit_Dr = Vitesse_Dr << 3;

//	Moteur gauche
	if (Vitesse_Ga < 0)
		{
		Sens_Ga = 1;	// marche arrire
		Vitesse_Ga = abs(Vitesse_Ga);
		}
	else
		Sens_Ga = 0;	// marche avant

	if (Vitesse_Ga > 30)
		Vitesse_Ga = 30;
	Vit_Ga = Vitesse_Ga << 3;
}
//==============================================================
//	Programme principal
//==============================================================
#zero_ram		// vide les registres en RAM
void	main(void)
{
INIT_Robot();
INIT_Interrup();
Test_Robot();
INIT_Ext_LDR();

While (1)
	{
		Mesure_Capteurs();
		Active_Moteurs();
	}
}
//==============================================================
